package college;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Daryle Niedermayer, I.S.P., PMP
 * @version 1.0 2008/05/05
 * 
 * This class will be developed during ASSIGNMENT 1, PART 1
 */
public class PersonSet {

    final int ARRAYSIZE = 10;
    Person[] pSet;
    
    /**
     * Public constructor
     */
    public PersonSet() {
        pSet = new Person[ARRAYSIZE];
    }
    
    /**
     * Adds a new member to the PersonSet array.
     * ASSIGNMENT 1 PART 3 throws an exception for an out of bound error
     * @param p a Person object to add to the PersonSet
     * @throws java.lang.Exception 
     */
    public void add(Person p) throws Exception {
        for (int i=0; i<=ARRAYSIZE; i++) {
            if (i==ARRAYSIZE) {
                throw new Exception("Cannot add new person: ARRAYSIZE exceeded!");
            }
            if (pSet[i] == null) {
                pSet[i] = p;
                break;
            } 
        }
    }

    /**
     * Prints out the NationalID, Firstname and Lastname of every non-null
     * entry in the PersonSet.
     */
    public void printSet() {
        for (int i=0; i<ARRAYSIZE; i++) {
            if (pSet[i] != null) {
                System.out.println(pSet[i].getNationalID() + " " 
                        + pSet[i].getFirstName() + " " + pSet[i].getLastName());
            }
        }
    }
    
    /**ASSIGNMENT 1 PART 2
     * 
     * @return the Person in the PersonSet with the oldest age
     */
    public Person getOldest() {
        Person x = null;
        int count = 0;
        
        for (int i=0; i<ARRAYSIZE; i++) {
            if (pSet[i] == null) {
                continue;           //Ignore empty array slots
            }
            if (x == null || x.getAge() < pSet[i].getAge()) { 
                x = pSet[i];
                count++;
            }
        }
        if (count == 0) {
            return null;
        }
        else return x;
        
    }
    
    /**ASSIGNMENT 1 PART 2
     * 
     * @return the Person in the PersonSet with the youngest age
     */

    public Person getYoungest() {
        Person x = null;
        int count = 0;
        
        for (int i=0; i<ARRAYSIZE; i++) {
            if (pSet[i] == null) {
                continue;           //Ignore empty array slots
            }
            if (x == null || x.getAge() > pSet[i].getAge()) { 
                x = pSet[i];
                count++;
            }
        }
        if (count == 0) {
            return null;
        }
        else return x;
    }

}
